.686
.mmx
.xmm
.model flat, stdcall
option casemap :none   ; case sensitive

      include \masm32\include\windows.inc
      include \masm32\include\kernel32.inc 
      include \masm32\include\Ws2_32.inc   
      include \masm32\include\user32.inc  
      include \masm32\include\msvcrt.inc  
      include \masm32\include\advapi32.inc  
      include \masm32\include\gdi32.inc
      include \masm32\include\USERENV.inc
      include \masm32\include\Wtsapi32.inc
      include \masm32\include\oleaut32.inc  
      include \masm32\include\ole32.inc
      include \masm32\include\Comdlg32.inc            
      include \masm32\include\Secur32.inc
      include \masm32\include\PSAPI.inc
      include \masm32\include\shell32.inc
      
      includelib \masm32\lib\Secur32.lib
      includelib \masm32\lib\PSAPI.lib               
      includelib \masm32\lib\Comdlg32.lib
      includelib \masm32\lib\ole32.lib
      includelib \masm32\lib\oleaut32.lib
      includelib \masm32\lib\Wtsapi32.lib
      includelib \masm32\lib\USERENV.lib  
      includelib \masm32\lib\gdi32.lib 
      includelib \masm32\lib\advapi32.lib 
      includelib \masm32\lib\user32.lib    
      includelib \masm32\lib\kernel32.lib
      includelib \masm32\lib\Ws2_32.lib   
      includelib \masm32\lib\msvcrt.lib    
      includelib \masm32\lib\gdi32.lib 
      includelib \masm32\lib\oldnames.lib  
      includelib \masm32\lib\libc.lib
      includelib \masm32\lib\shell32.lib     
      includelib \masm32\lib\Mfplat.lib
      includelib \masm32\lib\mfreadwrite.lib
      includelib \masm32\lib\Mf.lib
      includelib \masm32\lib\Mfplay.lib      
      includelib com.lib

      include    oaidl.inc
      include    Lib.inc

   externdef IID_IUnknown:dword


      InitializeWindow  proto :dword
      WindowProc        proto :dword, :dword, :dword, :dword
      MFPCreateMediaPlayer proto :dword, :dword, :dword, :dword, :dword, :dword
     
      OnClose           proto :dword
      OnKeyDown         proto :dword, :dword
    
      OnSize            proto :dword
      PlayMediaFile     proto :dword, :dword 
      FileOpenDialog1    proto :dword
      OnPaint           proto :dword

 ID_FILE_EXIT   equ               40002
 ID_FILE_OPEN   equ               0E101h

      

.data                           

 vtbIMFPMediaPlayerCallback  dd offset IUnknown_QueryInterface                                                                         
                             dd offset IUnknown_AddRef
                             dd offset IUnknown_Release                       
                             dd offset IMFPMediaPlayerCallback_OnMediaPlayerEvent                                      
               
 IID_IMFPMediaPlayerCallback  GUID <0766C8FFBh,05FDBh,04feah,<0A2h,08Dh,0B9h,012h,099h,06Fh,051h,0BDh>>
 
                                                       
 objIMFPMediaPlayerCallback OBJECT_DATA  <0, IMFPMediaPlayerCallback_INUM, offset pIMFPMediaPlayerCallback, offset IMFPMediaPlayerCallback_Constructor, offset IMFPMediaPlayerCallback_Destructor, 0, IMFPMediaPlayerCallback_SIZE, 0, 0, 0, 0, 0 >     

 IMFPMediaPlayerCallback_INUM     equ 2
 IMFPMediaPlayerCallback_SIZE     equ (sizeof OBJECT_ENTRY * IMFPMediaPlayerCallback_INUM) + sizeof IMFPMediaPlayerCallback_PRIVATE_DATA + sizeof OBJECT_DATA
 pIMFPMediaPlayerCallback         OBJECT_ENTRY <offset vtbIMFPMediaPlayerCallback, 0, offset IID_IUnknown>                   
                                  OBJECT_ENTRY <offset vtbIMFPMediaPlayerCallback, 0, offset IID_IMFPMediaPlayerCallback> 

.data?
    szFile        db 1000 dup (?)
    g_bHasVideo   dd ?
    g_pPlayer     dd ?
    g_pPlayerCB   dd ?

.data
   strFilter    db ".mp4",0,0,0     
   CLASS_NAME   db 'MFPlayWindowClass',0
   WINDOW_NAME  db "MP4 player window",0
   g_hwnd       dd ?
   msg          MSG <>
   hMhand       dword ?


.code
start: 

    invoke HeapSetInformation, 0, 1, 0,0
    invoke CoInitializeEx, 0, 6
    invoke GetModuleHandle, 0
    mov    hMhand, eax
    invoke InitializeWindow, addr g_hwnd              
    .while (1)
       invoke GetMessage, addr msg, 0, 0, 0    
       .if eax == 0 
          .break
       .endif
       invoke TranslateMessage, addr msg
       invoke DispatchMessage, addr msg
    .endw
     invoke DestroyWindow, g_hwnd
     invoke CoUninitialize
     invoke  ExitProcess, 0

;##########################################################

IMFPMediaPlayerCallback_Constructor  proc uses edi esi ebx this_:dword
 
         mov     ebx, this_
         mov     ebx, (OBJECT_ENTRY ptr [ebx]).pBase    
         invoke  CoTaskMemAlloc, sizeof  IMFPMediaPlayerCallback_PRIVATE_DATA 
         mov     (OBJECT_DATA ptr [ebx]).pPrivDat, eax  
         invoke  memset, (OBJECT_DATA ptr [ebx]).pPrivDat, 0, sizeof  IMFPMediaPlayerCallback_PRIVATE_DATA    
         mov     ebx, (OBJECT_DATA ptr [ebx]).pPrivDat                  
         ret

IMFPMediaPlayerCallback_Constructor  endp

;#############################################

IMFPMediaPlayerCallback_Destructor  proc uses edi esi ebx this_:dword 

         mov     ebx, this_
         mov     ebx, (OBJECT_ENTRY ptr [ebx]).pBase 
         invoke  CoTaskMemFree, (OBJECT_DATA ptr [ebx]).pPrivDat               
         ret

IMFPMediaPlayerCallback_Destructor  endp

;#############################################

IMFPMediaPlayerCallback_OnMediaPlayerEvent proc uses esi edi ebx this_:dword, pEventHeader:dword
    
    LOCAL  bHasVideo   : dword
    LOCAL  bIsSelected : dword
        
    mov    esi, pEventHeader
    .if  dword ptr (MFP_EVENT_HEADER ptr [esi]).hrEvent != 0
        jmp @@Exy
    .endif        
    .if dword ptr (MFP_EVENT_HEADER ptr [esi]).eEventType == MFP_EVENT_TYPE_MEDIAITEM_CREATED        
       .if (g_pPlayer)             
          mov   bHasVideo, 0
          mov   bIsSelected, 0        
          mov      ecx, pEventHeader
          coinvoke (MFP_MEDIAITEM_CREATED_EVENT ptr [ecx]).pMediaItem, IMFPMediaItem, HasVideo, addr bHasVideo, addr bIsSelected
          .if eax != 0
             jmp  @@Exy
          .endif
          mov   eax, bHasVideo
          or    eax, bIsSelected
          mov   g_bHasVideo, eax        
          mov      ecx, pEventHeader
          coinvoke g_pPlayer, IMFPMediaPlayer, SetMediaItem, (MFP_MEDIAITEM_CREATED_EVENT ptr [ecx]).pMediaItem       
       .endif    
    .elseif dword ptr (MFP_EVENT_HEADER ptr [esi]).eEventType == MFP_EVENT_TYPE_MEDIAITEM_SET                    
        coinvoke g_pPlayer, IMFPMediaPlayer, Play                
    .endif
@@Exy:
    ret
    
IMFPMediaPlayerCallback_OnMediaPlayerEvent endp

;##########################################################

InitializeWindow proc uses esi edi ebx pHwnd:dword

    LOCAL   wc    : WNDCLASSEX
    LOCAL   hwnd  : dword


    invoke memset, addr wc, 0, sizeof WNDCLASSEX
    mov    wc.cbSize, sizeof WNDCLASSEX    
    mov    wc.lpfnWndProc, offset WindowProc     
    mov    eax, hMhand
    mov    wc.hInstance, eax    
    invoke LoadCursor, 0, IDC_ARROW
    mov    wc.hCursor, eax    
    lea    eax, CLASS_NAME
    mov    wc.lpszClassName, eax  
    mov    wc.lpszMenuName, 65h

    invoke RegisterClassEx, addr wc
            
    invoke CreateWindowEx, 0, addr CLASS_NAME, addr WINDOW_NAME, WS_OVERLAPPEDWINDOW, 80000000h, 80000000h, 80000000h, 80000000h,0,0,hMhand,0
    mov    hwnd, eax
    invoke ShowWindow, hwnd, SW_SHOWDEFAULT
    invoke UpdateWindow, hwnd
    mov    ecx, pHwnd
    mov    eax, hwnd
    mov    [ecx], eax    
    mov    eax, 1
    ret

InitializeWindow endp

;##########################################################

WindowProc proc  hWin:dword, uMsg:dword, wParam:dword, lParam:dword

    LOCAL  sbUrl[300h] : byte

    .if uMsg == WM_COMMAND
        .if wParam == ID_FILE_OPEN          
           invoke FileOpenDialog1, hWin                   
           invoke MultiByteToWideChar, 0, 0, addr szFile, -1, addr sbUrl, 300h       
           invoke PlayMediaFile, hWin, addr sbUrl
        .elseif wParam == ID_FILE_EXIT
           invoke OnSize, hWin
        .endif
    .elseif uMsg == WM_PAINT
       invoke OnPaint, hWin  
    .elseif uMsg == WM_KEYDOWN
       invoke OnKeyDown, hWin, wParam
    .elseif uMsg == WM_SIZE
       invoke OnSize, hWin
    .elseif uMsg == WM_CLOSE
       invoke OnClose, hWin
    .elseif uMsg == WM_DESTROY
        invoke PostQuitMessage,0
        xor   eax, eax
        ret 
    .endif
    invoke DefWindowProc,hWin,uMsg,wParam,lParam
    ret

WindowProc endp

;##########################################################

OnClose proc hwnd:dword

    .if (g_pPlayer)    
        coinvoke g_pPlayer, IMFPMediaPlayer, Shutdown
        coinvoke g_pPlayer, IMFPMediaPlayer, Release
        mov      g_pPlayer, 0
    .endif
    .if (g_pPlayerCB)    
        coinvoke g_pPlayerCB, IMFPMediaPlayer, Release
        mov      g_pPlayerCB, 0
    .endif
    invoke PostQuitMessage, 0
    ret

OnClose endp

;##########################################################

OnKeyDown proc  hwnd:dword,  wParam : dword 

     LOCAL  hr    : dword
     LOCAL  state : dword
            
     mov    eax, wParam
     .if ax == VK_SPACE            
        .if (g_pPlayer)            
           mov    state, MFP_MEDIAPLAYER_STATE_EMPTY    
           coinvoke g_pPlayer, IMFPMediaPlayer, GetState, addr state
           mov      hr, eax
           .if (hr == 0)            
              .if (state == MFP_MEDIAPLAYER_STATE_PAUSED || state == MFP_MEDIAPLAYER_STATE_STOPPED)                    
                 coinvoke g_pPlayer,IMFPMediaPlayer, Play
                 mov      hr, eax                    
              .elseif (state == MFP_MEDIAPLAYER_STATE_PLAYING)    
                 coinvoke g_pPlayer, IMFPMediaPlayer, Pause
                 mov      hr, eax    
              .endif
           .endif
        .endif        
     .endif
     ret

OnKeyDown endp

;##########################################################

OnPaint proc  hwnd:dword

    LOCAL  ps : PAINTSTRUCT
    LOCAL  hdc : dword

    invoke BeginPaint, hwnd, addr ps
    mov    hdc, eax    
    .if (g_pPlayer && g_bHasVideo)
       coinvoke g_pPlayer, IMFPMediaPlayer, UpdateVideo    
    .else
       invoke FillRect, hdc, addr ps.rcPaint, COLOR_WINDOW+1    
    .endif
    invoke EndPaint, hwnd, addr ps
    ret

OnPaint endp

;##########################################################

OnSize proc hwnd:dword
    
    LOCAL state:dword

    .if g_pPlayer == 0 
       jmp   @@Err
    .endif
    mov      state, 0
    coinvoke g_pPlayer, IMFPMediaPlayer, GetState, addr state
    .if (state == SIZE_RESTORED)    
       .if (g_pPlayer)                  
          coinvoke g_pPlayer, IMFPMediaPlayer, UpdateVideo
       .endif
    .endif
@@Err:    
    ret

OnSize endp

;##########################################################

PlayMediaFile proc hwnd:dword, sURL:dword

    LOCAL hr : dword
    
    .if (g_pPlayer == 0)    
        push     offset objIMFPMediaPlayerCallback
        call     AllocObject
        mov      g_pPlayerCB, eax                
        coinvoke g_pPlayerCB, IMFPMediaItem, AddRef
        .if (g_pPlayerCB == 0)        
            mov  hr, E_OUTOFMEMORY
            jmp  done
        .endif
        invoke MFPCreateMediaPlayer, 0, 0, 0, g_pPlayerCB, hwnd, addr g_pPlayer
        .if ( hr!=0 ) 
          jmp  done
        .endif      
    .endif   
    coinvoke g_pPlayer, IMFPMediaPlayer, CreateMediaItemFromURL, sURL, 0, 0, 0
    mov      hr, eax
done:
    mov   eax, hr
    ret

PlayMediaFile endp

;##########################################################

FileOpenDialog1 proc hwnd:DWORD
    
          LOCAL  ofn : OPENFILENAME 
          

          invoke RtlZeroMemory, addr  ofn, sizeof ofn
          mov    ofn.lStructSize,  sizeof ofn
          mov    eax, hwnd
          mov    ofn.hWndOwner, eax
          mov    eax, offset szFile
          mov    ofn.lpstrFile,eax
          mov    ofn.nMaxFile, offset szFile
          mov    eax,  offset strFilter
          mov    ofn.lpstrFilter, eax
          mov    ofn.nFilterIndex, 1
          mov    ofn.Flags,OFN_PATHMUSTEXIST
          invoke GetOpenFileName, addr ofn 
          ret

FileOpenDialog1 endp

;#################################################### 


end start














