.686
.mmx
.xmm
.model flat, stdcall
option casemap :none   ; case sensitive

      include \masm32\include\windows.inc
      include \masm32\include\kernel32.inc 
      include \masm32\include\Ws2_32.inc   
      include \masm32\include\user32.inc  
      include \masm32\include\msvcrt.inc  
      include \masm32\include\advapi32.inc  
      include \masm32\include\gdi32.inc
      include \masm32\include\USERENV.inc
      include \masm32\include\Wtsapi32.inc
      include \masm32\include\oleaut32.inc  
      include \masm32\include\ole32.inc           
      include \masm32\include\Secur32.inc
      include \masm32\include\PSAPI.inc
      include \masm32\include\shell32.inc

      includelib \masm32\lib\Secur32.lib
      includelib \masm32\lib\PSAPI.lib            
      includelib \masm32\lib\ole32.lib
      includelib \masm32\lib\oleaut32.lib
      includelib \masm32\lib\Wtsapi32.lib
      includelib \masm32\lib\USERENV.lib  
      includelib \masm32\lib\gdi32.lib 
      includelib \masm32\lib\advapi32.lib 
      includelib \masm32\lib\user32.lib    
      includelib \masm32\lib\kernel32.lib
      includelib \masm32\lib\Ws2_32.lib   
      includelib \masm32\lib\msvcrt.lib    
      includelib \masm32\lib\gdi32.lib 
      includelib \masm32\lib\oldnames.lib  
      includelib \masm32\lib\libc.lib
      includelib \masm32\lib\shell32.lib          
      includelib \masm32\lib\Mfplat.lib
      includelib \masm32\lib\mfreadwrite.lib
      includelib \masm32\lib\Mf.lib
      includelib com.lib

      include    oaidl.inc
      include    Lib.inc
      include    mp4Recorder.inc 
      include    data.asm
      include    IMFByteStream.asm
      include    IMFAsyncResult.asm
    
       externdef IID_IUnknown:dword

      TopXY                     proto :dword, :dword
      TayWndProc                proto :dword, :dword, :dword, :dword
      MFCopyImage               proto :dword, :dword, :dword, :dword, :dword, :dword
      MFCreateMemoryBuffer      proto :dword, :dword
      MFShutdown                proto
      MFCreateSample            proto :dword
      MFCreateAttributes        proto :dword, :dword
      MFSetAttributeRatio       proto :dword, :dword, :dword, :dword
      MFSetAttributeSize        proto :dword, :dword, :dword, :dword
      MFCreateMediaType         proto :dword
      MFCreateMediaType         proto :dword
      MFCreateSinkWriterFromURL proto :dword, :dword, :dword, :dword
      MFStartup                 proto :dword, :dword
      InitializeSinkWriter      proto :dword, :dword, :dword, :dword
      WriteFrame                proto :dword, :dword, :dword, :dword, :dword
      WinMain                   proto :dword     
      ScreenCapture             proto :dword  
      lpTimerFunc               proto :dword  
      SetRegData                proto :dword, :dword, :dword, :dword







        
.data


 
    VIDEO_BIT_RATE                 equ 2000000
    VIDEO_FPS                      equ 5           
    pobj  dd ?
 

.code
start:
     invoke  malloc, sizeof CAPT_DATA
     mov     ebx, eax
     invoke  memset, ebx, 0, sizeof CAPT_DATA
     mov     (CAPT_DATA ptr [ebx]).dwBpp, VIDEO_BIT_RATE
     mov     (CAPT_DATA ptr [ebx]).dwfps, VIDEO_FPS
     mov     (CAPT_DATA ptr [ebx]).RecTime, 60*10 ; sec           
     
     invoke  CreateThread, 0, 0, addr lpTimerFunc, ebx, 1, addr tmrID  
     mov     tmrID, eax
     invoke  WaitForSingleObject, tmrID, -1            
     invoke  free, ebx
     invoke  ExitProcess, 0

    
;###############################################

lpTimerFunc proc uses esi edi ebx  arrg:dword

     LOCAL    Dishdc      : dword
     LOCAL    pmem        : dword
     LOCAL    stream      : dword
     LOCAL    pSinkWriter : dword  
     LOCAL    hEvnt       : dword
     LOCAL    dwTims      : dword
     LOCAL    dwSlep      : dword
            
     mov     eax, (CAPT_DATA ptr [ebx]).RecTime
     mov     ecx, (CAPT_DATA ptr [ebx]).dwfps
     mul     ecx
     mov     dwTims, eax
     mov     ebx, arrg        
     invoke  CoInitializeEx, 0, COINIT_APARTMENTTHREADED
     invoke  MFStartup, MF_VERSION, 0                  
     invoke  CreateDC, offset pwszDriver, 0, 0, 0
     mov     Dishdc, eax                                                                                       
     invoke  GetDeviceCaps, Dishdc, HORZRES 
     mov     (CAPT_DATA ptr [ebx]).InWidh, eax
     mov     (CAPT_DATA ptr [ebx]).OutWidh, eax                         
     invoke  GetDeviceCaps, Dishdc, VERTRES                 
     mov     (CAPT_DATA ptr [ebx]).InHigh, eax
     mov     (CAPT_DATA ptr [ebx]).OutHigh, eax
     invoke  GetDeviceCaps, Dishdc, BITSPIXEL

     mov     (CAPT_DATA ptr [ebx]).bpix, eax
     invoke  DeleteDC, Dishdc  
     
     mov     eax, (CAPT_DATA ptr [ebx]).InWidh
     mov     ecx, (CAPT_DATA ptr [ebx]).InHigh
     mul     ecx
     shl     eax, 2
     invoke  malloc, eax
     mov     pmem, eax  	     
     mov     (CAPT_DATA ptr [ebx]).memm, eax
     mov     eax, 10 * 1000 * 1000
     xor     edx, edx
     mov     ecx, (CAPT_DATA ptr [ebx]).dwfps
     div     ecx
     mov     (CAPT_DATA ptr [ebx]).Frtime,  eax   
     
     mov     eax, 1000
     xor     edx, edx
     mov     ecx, (CAPT_DATA ptr [ebx]).dwfps
     div     ecx 
     mov     dwSlep, eax
     invoke  CreateEvent, 0,0,1,0
     mov     hEvnt, eax  

     invoke  InitializeSinkWriter, addr szoutput, ebx, addr pSinkWriter, addr stream
     .While (1)
        invoke  WaitForSingleObject, hEvnt, dwSlep     
        invoke  ScreenCapture, ebx
        invoke  WriteFrame, pSinkWriter, ebx, stream, addr (CAPT_DATA ptr [ebx]).CrTime, addr  (CAPT_DATA ptr [ebx]).Frtime    
        dec     dwTims
        .if  dwTims == 0 
           .break
        .endif 
     .endw

     coinvoke pSinkWriter, IMFSinkWriter, Finalize
     coinvoke pSinkWriter, IUnknown, Release     
     invoke   CloseHandle, hEvnt   
     invoke   free, pmem     
     invoke   MFShutdown      
     ret 

lpTimerFunc endp

;###############################################  0.78f*fps*m_width*m_height)

InitializeSinkWriter  proc uses esi edi ebx  pFleName:dword, pdat:dword, ppWriter:dword, pStreamIndex:dword

    LOCAL    lpSinkWriter  : dword
    LOCAL    pMediaTypeOut : dword
    LOCAL    pMediaTypeIn  : dword
    LOCAL    streamIndex   : dword     
    LOCAL    m_MFAttr      : dword  
    LOCAL    codec         : dword
    LOCAL    quality       : VARIANT
    LOCAL    low_latency   : VARIANT
    LOCAL    gop_size      : VARIANT

    mov      ebx, pdat

    mov      m_MFAttr, 0
    invoke   MFCreateAttributes, addr m_MFAttr, 4      
    coinvoke m_MFAttr, IMFAttributes, SetGUID, addr MF_TRANSCODE_CONTAINERTYPE, addr MFTranscodeContainerType_FMPEG4      
    coinvoke m_MFAttr, IMFAttributes, SetUINT32, addr MF_READWRITE_ENABLE_HARDWARE_TRANSFORMS, 1    
    coinvoke m_MFAttr, IMFAttributes, SetUINT32, addr MF_LOW_LATENCY, 1

    push     offset objIMFByteStream
    call     AllocObject
    mov      pobj, eax
    
    coinvoke pobj, IMFByteStream, AddRef
    
    invoke   MFCreateSinkWriterFromURL, 0, pobj, m_MFAttr, addr lpSinkWriter                   
    


    invoke   MFCreateMediaType, addr pMediaTypeOut  
                 
    coinvoke pMediaTypeOut, IMFTopology, SetGUID, addr MF_MT_MAJOR_TYPE, addr MFMediaType_Video             
    coinvoke pMediaTypeOut, IMFTopology, SetGUID, addr MF_MT_SUBTYPE, addr VIDEO_ENCODING_FORMAT           
    coinvoke pMediaTypeOut, IMFTopology, SetUINT32, addr MF_MT_AVG_BITRATE, (CAPT_DATA ptr [ebx]).dwBpp               
    coinvoke pMediaTypeOut, IMFTopology, SetUINT32, addr MF_MT_INTERLACE_MODE, MFVideoInterlace_Progressive                              
    coinvoke pMediaTypeOut, IMFTopology, SetUINT64, addr MF_MT_FRAME_SIZE, (CAPT_DATA ptr [ebx]).OutHigh, (CAPT_DATA ptr [ebx]).OutWidh               
    coinvoke pMediaTypeOut, IMFTopology, SetUINT64, addr MF_MT_FRAME_RATE,  1, (CAPT_DATA ptr [ebx]).dwfps           
    coinvoke pMediaTypeOut, IMFTopology, SetUINT64, addr MF_MT_PIXEL_ASPECT_RATIO, 1, 1 

    coinvoke lpSinkWriter, IMFSinkWriter, AddStream, pMediaTypeOut, addr streamIndex                   
    
    invoke   MFCreateMediaType, addr pMediaTypeIn               
    
    coinvoke pMediaTypeIn, IMFTopology, SetGUID, addr MF_MT_MAJOR_TYPE, addr MFMediaType_Video               
    coinvoke pMediaTypeIn, IMFTopology, SetGUID, addr MF_MT_SUBTYPE, addr MFVideoFormat_RGB32  ;VIDEO_INPUT_FORMAT                 
    coinvoke pMediaTypeIn, IMFTopology, SetUINT32, addr MF_MT_INTERLACE_MODE, MFVideoInterlace_Progressive                 
    coinvoke pMediaTypeIn, IMFTopology, SetUINT32, addr MF_MT_ALL_SAMPLES_INDEPENDENT, 1  
                   
    coinvoke pMediaTypeIn, IMFTopology, SetUINT64, addr MF_MT_FRAME_SIZE, (CAPT_DATA ptr [ebx]).InHigh, (CAPT_DATA ptr [ebx]).InWidh              
    coinvoke pMediaTypeIn, IMFTopology, SetUINT64, addr MF_MT_FRAME_RATE, 1, (CAPT_DATA ptr [ebx]).dwfps               
    coinvoke pMediaTypeIn, IMFTopology, SetUINT64, addr MF_MT_PIXEL_ASPECT_RATIO, 1, 1             

    coinvoke lpSinkWriter, IMFSinkWriter, SetInputMediaType, streamIndex, pMediaTypeIn, 0

     
    coinvoke lpSinkWriter, IMFSinkWriter, GetServiceForStream, streamIndex, addr GUID_NULL, addr IID_ICodecAPI, addr codec                         

    mov   quality.vt, VT_UI4
    mov   quality.ulVal, 80
    coinvoke codec, ICodecAPI, SetValue, addr CODECAPI_AVEncCommonQualityVsSpeed, addr quality                                             
    
    mov      low_latency.vt, VT_BOOL    
    mov      low_latency.boolVal, VARIANT_TRUE
    coinvoke codec, ICodecAPI, SetValue, addr CODECAPI_AVLowLatencyMode, addr low_latency
                 
    mov    gop_size.vt, VT_UI4
    mov    gop_size.ulVal, 82    
    coinvoke codec, ICodecAPI, SetValue, addr CODECAPI_AVEncMPVGOPSize, addr gop_size

    coinvoke lpSinkWriter, IMFSinkWriter, BeginWriting

    mov      ecx, ppWriter
    mov      eax, lpSinkWriter
    mov      [ecx], eax
    
    coinvoke lpSinkWriter, IUnknown, AddRef 
    mov      ecx, pStreamIndex
    mov      eax, streamIndex
    mov      [ecx], eax        
    
    coinvoke lpSinkWriter, IUnknown, Release 
    coinvoke pMediaTypeOut, IUnknown, Release     
    coinvoke pMediaTypeIn, IUnknown, Release   
    ret

InitializeSinkWriter endp

;###############################################

WriteFrame proc uses esi edi ebx lpSinkWriter:dword, pMain:dword, lpStreamIndex:dword, lrtStart1:dword,  lrtStart2:dword
        
    LOCAL    pSample   : dword
    LOCAL    pBuffer   : dword
    LOCAL    pData     : dword
    LOCAL    cbBuffer  : dword
    LOCAL    cbWidth   : dword

    mov      ebx, pMain
    mov      eax, (CAPT_DATA ptr [ebx]).InWidh
    mov      ecx, (CAPT_DATA ptr [ebx]).bpix
    mul      ecx
    shr      eax, 3
    mov      cbWidth, eax
    
    mov      ecx, (CAPT_DATA ptr [ebx]).InHigh
    mul      ecx
    mov      cbBuffer, eax
    
    mov      pBuffer, 0
    invoke   MFCreateMemoryBuffer, cbBuffer, addr pBuffer        
    mov      pData, 0
    coinvoke pBuffer, IMFMediaBuffer, Lock, addr pData, 0, 0    

    invoke   MFCopyImage, pData, cbWidth,  (CAPT_DATA ptr [ebx]).memm, cbWidth, cbWidth, (CAPT_DATA ptr [ebx]).InHigh    

    coinvoke pBuffer, IMFMediaBuffer, Unlock
    coinvoke pBuffer, IMFMediaBuffer, SetCurrentLength, cbBuffer   
    
    invoke   MFCreateSample, addr pSample   
    coinvoke pSample, IMFSample, AddBuffer, pBuffer    
 
    mov      ecx, lrtStart1
    coinvoke pSample, IMFSample, SetSampleTime, [ecx], [ecx+4]     

    mov      ecx, lrtStart2    
    coinvoke pSample, IMFSample, SetSampleDuration, [ecx], [ecx+4]  

    fild     qword ptr [lrtStart1]
    fild     qword ptr [lrtStart2]
    fadd
    fistp    qword ptr [lrtStart1]

    coinvoke lpSinkWriter, IMFSinkWriter, WriteSample, lpStreamIndex, pSample              
    coinvoke pSample, IUnknown, Release 
    coinvoke pBuffer, IUnknown, Release 
    ret

WriteFrame endp

;###############################################

ScreenCapture proc uses esi ebx edi  pmain:dword

      LOCAL   Dishdc     : dword
      LOCAL   cphDisp    : dword
      LOCAL   hlBmp      : dword
      LOCAL   bmpInfo    : BITMAPINFO
      LOCAL   DispWidht  : dword
      LOCAL   DispHeight : dword
      LOCAL   oldbmp     : dword
                        
      mov     ebx, pmain  
      invoke  CreateDC, offset pwszDriver, 0, 0, 0
      mov     Dishdc, eax                                                                                      

      mov     eax, (CAPT_DATA ptr [ebx]).InWidh
      mov     DispWidht, eax                         
          
      mov     eax, (CAPT_DATA ptr [ebx]).InHigh
      mov     DispHeight, eax

      invoke  CreateCompatibleDC, Dishdc                                  
      mov     cphDisp, eax                                                            
                             
      invoke  CreateCompatibleBitmap, Dishdc, DispWidht, DispHeight
      mov     hlBmp, eax                              

      invoke  SelectObject, cphDisp, hlBmp
      mov     oldbmp, eax  

      invoke  GdiFlush     
  
			invoke  memset, addr bmpInfo, 0, sizeof bmpInfo
			mov     bmpInfo.bmiHeader.biSize, sizeof BITMAPINFOHEADER
			mov     eax, (CAPT_DATA ptr [ebx]).bpix
			mov     bmpInfo.bmiHeader.biBitCount, ax
			mov     bmpInfo.bmiHeader.biCompression, BI_RGB
			mov     eax, DispWidht
			mov     ecx, DispHeight
			mul     ecx
			mov     ecx, (CAPT_DATA ptr [ebx]).bpix
			mul     ecx
			shr     eax, 3 
			mov     bmpInfo.bmiHeader.biSizeImage, eax
			mov     bmpInfo.bmiHeader.biPlanes, 1
			mov     eax, DispHeight			    
			mov     bmpInfo.bmiHeader.biHeight, eax
			mov     eax, DispWidht
			mov     bmpInfo.bmiHeader.biWidth, eax
;-                                         
      invoke  BitBlt, cphDisp, 0, 0, DispWidht, DispHeight, Dishdc, 0, 0, SRCCOPY                                                                                                     
      invoke  GetDIBits, Dishdc, hlBmp, 0, DispHeight, (CAPT_DATA ptr [ebx]).memm, addr bmpInfo.bmiHeader, DIB_RGB_COLORS                                   
;-
      invoke  SelectObject, Dishdc, oldbmp
      invoke  DeleteObject, hlBmp 
      invoke  DeleteDC, cphDisp
      invoke  DeleteDC, Dishdc                         
      ret
                
ScreenCapture endp  

;####################################################

end start