COINIT_APARTMENTTHREADED  equ 2
MF_VERSION  equ 20070h

wchar   typedef     word


L MACRO sText:REQ
    LOCAL str, chr, flag, cchr
        cchr TEXTEQU <>
        str  TEXTEQU <>
        flag TEXTEQU <.>
        FORC chr, <&sText> 
            IFIDN flag, <\>     ;; IF flag == '\'  we're in control char mode
                IFIDN <&chr>, <\>           ;; '\\' makes a single backslash
                    cchr TEXTEQU <"\">      ;; just as in C
                ENDIF
                IFIDN <&chr>, <|>           ;; a pipe gives '!'
                    cchr TEXTEQU <"!!">     ;; need 2 because of macro alias
                ENDIF
                IFIDN <&chr>, <n>           ;;  "n" gives a new line
                    cchr TEXTEQU <13,10>
                ENDIF
                IFIDN <&chr>, <0>           ;; an "0" (terminating zero)
                    cchr TEXTEQU <0>
                ENDIF
                flag TEXTEQU <.>
            ELSE                ;; ELSE, not in control mode
                IFIDN <&chr>, <\>           ;; if chr =='\', go to control mode
                    flag TEXTEQU <\>
                    cchr TEXTEQU <>
                ELSE                        ;; else must be a regular char
                    cchr CATSTR <">, <chr>, <"> 
                ENDIF
            ENDIF
            IFDIF str, <>                   ;; need a comma before we add new
                IFDIF flag, <\>
                    str CATSTR str, <,>
                ENDIF
            ENDIF
            IFDIF cchr, <>                  ;; check we don't add a blank
                str CATSTR str, &cchr
            ENDIF
        ENDM
        EXITM str
    ENDM

      eAVEncH264VProfile_Base  equ   66
      VIDEO_ENCODING_FORMAT  equ   MFVideoFormat_H264
      VIDEO_INPUT_FORMAT     equ  MFVideoFormat_RGB32  

CAPT_DATA struct
   OutWidh  dd ?
   OutHigh  dd ?
   InWidh   dd ?
   InHigh   dd ?
   bpix     dd ?
   dwfps    dd ?
   dwBpp    dd ?  
   memm     dd ?    
   RecTime  dd ?
   Frtime   dd ?
   Frtime1  dd ?
   CrTime   dd ? 
            dd ?
CAPT_DATA ends



; MFVideoInterlaceMode 
  MFVideoInterlace_Unknown                      equ 0
  MFVideoInterlace_Progressive                  equ 2
  MFVideoInterlace_FieldInterleavedUpperFirst   equ 3
  MFVideoInterlace_FieldInterleavedLowerFirst   equ 4
  MFVideoInterlace_FieldSingleUpper             equ 5
  MFVideoInterlace_FieldSingleLower             equ 6
  MFVideoInterlace_MixedInterlaceOrProgressive  equ 7
  MFVideoInterlace_Last                         equ 8 
  MFVideoInterlace_ForceDWORD                   equ 07FFFFFFFh



IMFTopology struct
    IMFTopology_QueryInterface           comethod3 ? ;0
    IMFTopology_AddRef                   comethod1 ? ;4
    IMFTopology_Release                  comethod1 ? ;8          
    IMFTopology_GetItem                  comethod3 ? ;c      
    IMFTopology_GetItemType              comethod3 ? ;10       
    IMFTopology_CompareItem              comethod4 ? ;14         
    IMFTopology_Compare                  comethod4 ? ;18         
    IMFTopology_GetUINT32                comethod3 ? ;1c        
    IMFTopology_GetUINT64                comethod3 ? ;20        
    IMFTopology_GetDouble                comethod3 ? ;24        
    IMFTopology_GetGUID                  comethod3 ? ;28        
    IMFTopology_GetStringLength          comethod3 ? ;2c         
    IMFTopology_GetString                comethod5 ? ;30         
    IMFTopology_GetAllocatedString       comethod4 ? ;34         
    IMFTopology_GetBlobSize              comethod3 ? ;38         
    IMFTopology_GetBlob                  comethod5 ? ;3c         
    IMFTopology_GetAllocatedBlob         comethod4 ? ;40        
    IMFTopology_GetUnknown               comethod4 ? ;44         
    IMFTopology_SetItem                  comethod3 ? ;48         
    IMFTopology_DeleteItem               comethod2 ? ;4c        
    IMFTopology_DeleteAllItems           comethod1 ? ;50        
    IMFTopology_SetUINT32                comethod3 ? ;54 
    IMFTopology_SetUINT64                comethod4 ? ;58        [esi+58h]  MFSetAttributeSize@16
    IMFTopology_SetDouble                comethod3 ? ;5c         
    IMFTopology_SetGUID                  comethod3 ? ;60         
    IMFTopology_SetString                comethod3 ? ;64         
    IMFTopology_SetBlob                  comethod4 ? ;68         
    IMFTopology_SetUnknown               comethod3 ? ;6c         
    IMFTopology_LockStore                comethod1 ? ;70         
    IMFTopology_UnlockStore              comethod1 ? ;74         
    IMFTopology_GetCount                 comethod2 ? ;78        
    IMFTopology_GetItemByIndex           comethod4 ? ;7c         
    IMFTopology_CopyAllItems             comethod2 ? ;80        
    IMFTopology_GetTopologyID            comethod2 ? ;84            
    IMFTopology_AddNode                  comethod2 ? ;88          
    IMFTopology_RemoveNode               comethod2 ? ;8c          
    IMFTopology_GetNodeCount             comethod2 ? ;90        
    IMFTopology_GetNode                  comethod3 ? ;94        
    IMFTopology_Clear                    comethod1 ? ;98                    
    IMFTopology_CloneFrom                comethod2 ? ;9c         
    IMFTopology_GetNodeByID              comethod3 ? ;a0         
    IMFTopology_GetSourceNodeCollection  comethod2 ? ;a4        
    IMFTopology_GetOutputNodeCollection  comethod2 ? ;a8 
IMFTopology ends



IMFSinkWriter struct
    IMFSinkWriter_QueryInterface        comethod3 ? ;0
    IMFSinkWriter_AddRef                comethod1 ? ;4
    IMFSinkWriter_Release               comethod1 ? ;8       
    IMFSinkWriter_AddStream             comethod3 ? ;c        
    IMFSinkWriter_SetInputMediaType     comethod4 ? ;10        
    IMFSinkWriter_BeginWriting          comethod1 ? ;14         
    IMFSinkWriter_WriteSample           comethod3 ? ;18        
    IMFSinkWriter_SendStreamTick        comethod3 ? ;1c         
    IMFSinkWriter_PlaceMarker           comethod3 ? ;20        
    IMFSinkWriter_NotifyEndOfSegment    comethod2 ? ;24        
    IMFSinkWriter_Flush                 comethod2 ? ;28        
    IMFSinkWriter_Finalize              comethod1 ? ;2c         
    IMFSinkWriter_GetServiceForStream   comethod5 ? ;30        
    IMFSinkWriter_GetStatistics         comethod3 ? ;34 
IMFSinkWriter ends
        

IMFMediaBuffer struct
    IMFMediaBuffer_QueryInterface        comethod3 ? ;0
    IMFMediaBuffer_AddRef                comethod1 ? ;4
    IMFMediaBuffer_Release               comethod1 ? ;8         
    IMFMediaBuffer_Lock                  comethod4 ? ;c         
    IMFMediaBuffer_Unlock                comethod1 ? ;10        
    IMFMediaBuffer_GetCurrentLength      comethod2 ? ;14         
    IMFMediaBuffer_SetCurrentLength      comethod2 ? ;18        
    IMFMediaBuffer_GetMaxLength          comethod2 ? ;1c
IMFMediaBuffer ends


IMFSample struct
    IMFSample_QueryInterface      comethod3 ? ;0
    IMFSample_AddRef              comethod1 ? ;4
    IMFSample_Release             comethod1 ? ;8          
    IMFSample_GetItem             comethod3 ? ;c        
    IMFSample_GetItemType         comethod3 ? ;10        
    IMFSample_CompareItem         comethod4 ? ;14        
    IMFSample_Compare             comethod4 ? ;18        
    IMFSample_GetUINT32           comethod3 ? ;1c         
    IMFSample_GetUINT64           comethod3 ? ;20         
    IMFSample_GetDouble           comethod3 ? ;24         
    IMFSample_GetGUID             comethod3 ? ;28         
    IMFSample_GetStringLength     comethod3 ? ;2c        
    IMFSample_GetString           comethod5 ? ;30         
    IMFSample_GetAllocatedString  comethod4 ? ;34        
    IMFSample_GetBlobSize         comethod3 ? ;38         
    IMFSample_GetBlob             comethod5 ? ;3c         
    IMFSample_GetAllocatedBlob    comethod4 ? ;40         
    IMFSample_GetUnknown          comethod4 ? ;44         
    IMFSample_SetItem             comethod3 ? ;48        
    IMFSample_DeleteItem          comethod2 ? ;4c        
    IMFSample_DeleteAllItems      comethod1 ? ;50        
    IMFSample_SetUINT32           comethod3 ? ;54         
    IMFSample_SetUINT64           comethod3 ? ;58         
    IMFSample_SetDouble           comethod3 ? ;5c 
    IMFSample_SetGUID             comethod4 ? ;60         
    IMFSample_SetString           comethod3 ? ;64        
    IMFSample_SetBlob             comethod4 ? ;68         
    IMFSample_SetUnknown          comethod3 ? ;6c         
    IMFSample_LockStore           comethod1 ? ;70         
    IMFSample_UnlockStore         comethod1 ? ;74        
    IMFSample_GetCount            comethod2 ? ;78        
    IMFSample_GetItemByIndex      comethod4 ? ;7c         
    IMFSample_CopyAllItems        comethod2 ? ;80         
    IMFSample_GetSampleFlags      comethod3 ? ;84        
    IMFSample_SetSampleFlags      comethod2 ? ;88         
    IMFSample_GetSampleTime       comethod3 ? ;8c         
    IMFSample_SetSampleTime       comethod3 ? ;90        
    IMFSample_GetSampleDuration   comethod3 ? ;94         
    IMFSample_SetSampleDuration   comethod3 ? ;98         
    IMFSample_GetBufferCount      comethod3 ? ;9c         
    IMFSample_GetBufferByIndex    comethod4 ? ;a0         
    IMFSample_ConvertToContiguousBuffer    comethod3 ? ;a4         
    IMFSample_AddBuffer           comethod2 ? ;a8         
    IMFSample_RemoveBufferByIndex comethod2 ? ;ac         
    IMFSample_RemoveAllBuffers    comethod1 ? ;b0         
    IMFSample_GetTotalLength      comethod3 ? ;b4         
    IMFSample_CopyToBuffer        comethod2 ? ;b8 
IMFSample ends



ICodecAPI struct
    ICodecAPI_QueryInterface      comethod3 ? ;0
    ICodecAPI_AddRef              comethod1 ? ;4
    ICodecAPI_Release             comethod1 ? ;8          
    ICodecAPI_IsSupported         comethod2 ? ;c        
    ICodecAPI_IsModifiable        comethod2 ? ;10        
    ICodecAPI_GetParameterRange   comethod5 ? ;14         
    ICodecAPI_GetParameterValues  comethod4 ? ;18         
    ICodecAPI_GetDefaultValue     comethod3 ? ;1c        
    ICodecAPI_GetValue            comethod3 ? ;20        
    ICodecAPI_SetValue            comethod3 ? ;24        
    ICodecAPI_RegisterForEvent    comethod3 ? ;28        
    ICodecAPI_UnregisterForEvent  comethod2 ? ;2c         
    ICodecAPI_SetAllDefaults      comethod1 ? ;30         
    ICodecAPI_SetValueWithNotify  comethod5 ? ;34         
    ICodecAPI_SetAllDefaultsWithNotify   comethod3 ? ;38         
    ICodecAPI_GetAllSettings             comethod2 ? ;3c
    ICodecAPI_SetAllSettings             comethod2 ? ;40         
    ICodecAPI_SetAllSettingsWithNotify   comethod4 ? ;44 
ICodecAPI ends
        



IMFTransform struct
    IMFTransform_QueryInterface            comethod3 ? ;0
    IMFTransform_AddRef                    comethod1 ? ;4
    IMFTransform_Release                   comethod1 ? ;8        
    IMFTransform_GetStreamLimits           comethod5 ? ;0         
    IMFTransform_GetStreamCount            comethod3 ? ;0        
    IMFTransform_GetStreamIDs              comethod5 ? ;0         
    IMFTransform_GetInputStreamInfo        comethod3 ? ;0         
    IMFTransform_GetOutputStreamInfo       comethod3 ? ;0         
    IMFTransform_GetAttributes             comethod2 ? ;0         
    IMFTransform_GetInputStreamAttributes  comethod3 ? ;0         
    IMFTransform_GetOutputStreamAttributes comethod3 ? ;0         
    IMFTransform_DeleteInputStream         comethod2 ? ;0         
    IMFTransform_AddInputStreams           comethod3 ? ;0         
    IMFTransform_GetInputAvailableType     comethod4 ? ;0         
    IMFTransform_GetOutputAvailableType    comethod4 ? ;0         
    IMFTransform_SetInputType              comethod4 ? ;0         
    IMFTransform_SetOutputType             comethod4 ? ;0         
    IMFTransform_GetInputCurrentType       comethod3 ? ;0         
    IMFTransform_GetOutputCurrentType      comethod3 ? ;0         
    IMFTransform_GetInputStatus            comethod3 ? ;0 
    IMFTransform_GetOutputStatus           comethod2 ? ;0         
    IMFTransform_SetOutputBounds           comethod3 ? ;0         
    IMFTransform_ProcessEvent              comethod3 ? ;0         
    IMFTransform_ProcessMessage            comethod3 ? ;0         
    IMFTransform_ProcessInput              comethod4 ? ;0 
    IMFTransform_ProcessOutput             comethod5 ? ;0 
IMFTransform ends

;MF_FILE_ACCESSMODE
        MF_ACCESSMODE_READ	equ 1
        MF_ACCESSMODE_WRITE	equ 2
        MF_ACCESSMODE_READWRITE	equ 3

;MF_FILE_OPENMODE    
        MF_OPENMODE_FAIL_IF_NOT_EXIST	equ 0
        MF_OPENMODE_FAIL_IF_EXIST	   equ 1
        MF_OPENMODE_RESET_IF_EXIST	equ 2
        MF_OPENMODE_APPEND_IF_EXIST	equ 3
        MF_OPENMODE_DELETE_IF_EXIST	 equ 4

;MF_FILE_FLAGS
        MF_FILEFLAGS_NONE	equ 0
        MF_FILEFLAGS_NOBUFFERING	equ 1
        MF_FILEFLAGS_ALLOW_WRITE_SHARING	equ 2


IMFByteStream struct
    IMFByteStream_QueryInterface       comethod3 ? ;0
    IMFByteStream_AddRef               comethod1 ? ;4
    IMFByteStream_Release              comethod1 ? ;8        
    IMFByteStream_GetCapabilities      comethod2 ? ;c        
    IMFByteStream_GetLength            comethod2 ? ;10        
    IMFByteStream_SetLength            comethod2 ? ;14         
    IMFByteStream_GetCurrentPosition   comethod2 ? ;18        
    IMFByteStream_SetCurrentPosition   comethod2 ? ;1c         
    IMFByteStream_IsEndOfStream        comethod2 ? ;20        
    IMFByteStream_Read                 comethod4 ? ;24        
    IMFByteStream_BeginRead            comethod5 ? ;28        
    IMFByteStream_EndRead              comethod3 ? ;2c         
    IMFByteStream_Write                comethod4 ? ;30        
    IMFByteStream_BeginWrite           comethod5 ? ;34         
    IMFByteStream_EndWrite             comethod3 ? ;38         
    IMFByteStream_Seek                 comethod5 ? ;3c       
    IMFByteStream_Flush                comethod1 ? ;40         
    IMFByteStream_Close                comethod1 ? ;44 
IMFByteStream ends

;MFT_OUTPUT_DATA_BUFFER_FLAGS    
        MFT_OUTPUT_DATA_BUFFER_INCOMPLETE	equ 0x1000000h
        MFT_OUTPUT_DATA_BUFFER_FORMAT_CHANGE	equ 0100h
        MFT_OUTPUT_DATA_BUFFER_STREAM_END	equ 0200h
        MFT_OUTPUT_DATA_BUFFER_NO_SAMPLE	equ 0300h
    
    

;MFT_INPUT_STREAM_INFO_FLAGS    
        MFT_INPUT_STREAM_WHOLE_SAMPLES	equ 01h
        MFT_INPUT_STREAM_SINGLE_SAMPLE_PER_BUFFER	equ 02h
        MFT_INPUT_STREAM_FIXED_SAMPLE_SIZE	equ 04h
        MFT_INPUT_STREAM_HOLDS_BUFFERS	equ 08h
        MFT_INPUT_STREAM_DOES_NOT_ADDREF	equ 0100h
        MFT_INPUT_STREAM_REMOVABLE	equ 0200h
        MFT_INPUT_STREAM_OPTIONAL	equ 0400h
        MFT_INPUT_STREAM_PROCESSES_IN_PLACE	equ 0800h


;MFT_OUTPUT_STREAM_INFO_FLAGS  
        MFT_OUTPUT_STREAM_WHOLE_SAMPLES	 equ  01h
        MFT_OUTPUT_STREAM_SINGLE_SAMPLE_PER_BUFFER	equ 02h
        MFT_OUTPUT_STREAM_FIXED_SAMPLE_SIZE	equ 04h
        MFT_OUTPUT_STREAM_DISCARDABLE	equ 08h
        MFT_OUTPUT_STREAM_OPTIONAL	equ  010h
        MFT_OUTPUT_STREAM_PROVIDES_SAMPLES	equ 0100h
        MFT_OUTPUT_STREAM_CAN_PROVIDE_SAMPLES	equ 0200
        MFT_OUTPUT_STREAM_LAZY_READ	equ 0400h
        MFT_OUTPUT_STREAM_REMOVABLE	equ 0800h
      

IMFMediaSink struct
    IMFMediaSink_QueryInterface       comethod3 ? ;0
    IMFMediaSink_AddRef               comethod1 ? ;4
    IMFMediaSink_Release              comethod1 ? ;8         
    IMFMediaSink_GetCharacteristics   comethod2 ? ;c        
    IMFMediaSink_AddStreamSink        comethod4 ? ;10        
    IMFMediaSink_RemoveStreamSink     comethod2 ? ;14         
    IMFMediaSink_GetStreamSinkCount   comethod2 ? ;18         
    IMFMediaSink_GetStreamSinkByIndex comethod3 ? ;1c        
    IMFMediaSink_GetStreamSinkById    comethod3 ? ;20         
    IMFMediaSink_SetPresentationClock comethod2 ? ;24         
    IMFMediaSink_GetPresentationClock comethod2 ? ;28
IMFMediaSink ends



MFT_INPUT_STREAM_INFO struct    
    hnsMaxLatency1  dd ?
    hnsMaxLatency2  dd ?
    dwFlags         dd ?
    cbSize          dd ?
    cbMaxLookahead  dd ?
    cbAlignment     dd ?
MFT_INPUT_STREAM_INFO ends

MFT_OUTPUT_STREAM_INFO struct    
    dwFlags     dd ?
    cbSize      dd ?
    cbAlignment dd ?
MFT_OUTPUT_STREAM_INFO ends

MFT_OUTPUT_DATA_BUFFER struct    
    dwStreamID  dd ?
    pSample     dd ?   ;IMFSample
    dwStatus    dd ?
    pEvents     dd ?   ;IMFCollection
MFT_OUTPUT_DATA_BUFFER ends


; IID_IMFAttributes, 0x2cd2d921, 0xc447, 0x44a7, 0xa1,0x3c, 0x4a,0xda,0xbf,0xc2,0x47,0xe3



IMFAttributes struct
    IMFAttributes_QueryInterface       comethod3 ? ;0
    IMFAttributes_AddRef               comethod1 ? ;4
    IMFAttributes_Release              comethod1 ? ;8   
    IMFAttributes_GetItem              comethod3 ? ;c
    IMFAttributes_GetItemType          comethod3 ? ;10 
    IMFAttributes_CompareItem          comethod4 ? ;14
    IMFAttributes_Compare              comethod4 ? ;18
    IMFAttributes_GetUINT32            comethod3 ? ;1c
    IMFAttributes_GetUINT64            comethod3 ? ;20
    IMFAttributes_GetDouble            comethod3 ? ;24
    IMFAttributes_GetGUID              comethod3 ? ;28
    IMFAttributes_GetStringLength      comethod3 ? ;2c
    IMFAttributes_GetString            comethod5 ? ;30
    IMFAttributes_GetAllocatedString   comethod4 ? ;34
    IMFAttributes_GetBlobSize          comethod3 ? ;38
    IMFAttributes_GetBlob              comethod5 ? ;3c
    IMFAttributes_GetAllocatedBlob     comethod4 ? ;40
    IMFAttributes_GetUnknown           comethod4 ? ;44
    IMFAttributes_SetItem              comethod3 ? ;48 
    IMFAttributes_DeleteItem           comethod2 ? ;4c   
    IMFAttributes_DeleteAllItems       comethod1 ? ;50
    IMFAttributes_SetUINT32            comethod3 ? ;54
    IMFAttributes_SetUINT64            comethod3 ? ;58
    IMFAttributes_SetDouble            comethod3 ? ;5c
    IMFAttributes_SetGUID              comethod3 ? ;60
    IMFAttributes_SetString            comethod3 ? ;64
    IMFAttributes_SetBlob              comethod4 ? ;68
    IMFAttributes_SetUnknown           comethod3 ? ;6c
    IMFAttributes_LockStore            comethod1 ? ;70
    IMFAttributes_UnlockStore          comethod1 ? ;74  
    IMFAttributes_GetCount             comethod2 ? ;78 
    IMFAttributes_GetItemByIndex       comethod4 ? ;7c
    IMFAttributes_CopyAllItems         comethod2 ? ;80
IMFAttributes  ends   


